'======================================
'= Custom MetaBase Credential Storage =
'= System Setup Script Version 1.0    =
'======================================
'=   Copyright (c)2001 Thomas Carpe.  =
'=     http://www.seizetheweb.net     =
'=        All Rights Reserved.        =
'=                                    =
'= Permission to use and modify is    =
'= hereby given provided that you do  =
'= not remove this notice.            =
'======================================

Dim MachineName
Dim NewClassName
Dim SchemaObj

''
'Dim ArgObj
'Set ArgObj=WScript.Arguments
'MachineName = ArgObj.Item (0)
'' The above code would allow you to run this script against another server

MachineName = "localhost"

' Bind to the Schema container object.
Set SchemaObj = GetObject ("IIS://" & MachineName & "/Schema")

' Do the legwork
NewClassName = "DataAccessMethods"
If CreateClass(NewClassName) Then
	Call CreateProperty_Plus_AddToClass(NewClassName, "ODBCDataSource", "")
	Call CreateProperty_Plus_AddToClass(NewClassName, "ODBCUserName", "")
	Call CreateProperty_Plus_AddToClass(NewClassName, "ODBCPassword", "")
	Call AddToClass(NewClassName, "AdminACL")
	Call AddToClass(NewClassName, "KeyType")
End If
NewClassName = "DataAccessStorage"
If CreateClass(NewClassName) Then
	Call AddToClass(NewClassName, "KeyType")
	Call AddToClass(NewClassName, "AdminACL")
	'Here we need to inform this class that it may only contain AccessMethods
End If

''''''''''''''''''''''''''''''''''''''''''
' Create Property and Add it to the Class
'
' This routine was probably not necessary, but
' will prevent some spelling errors and the like
'
Sub CreateProperty_Plus_AddToClass(ClassName, PropertyName, Syntax)
	Dim Success
	Success = CreateProperty(PropertyName, Syntax)
	If Success Then
		Success = AddToClass(ClassName, PropertyName)
	End If
End Sub

''''''''''''''''''''''''''''''''''''''
'   Create DataAccessMethods Class   '
''''''''''''''''''''''''''''''''''''''
Function CreateClass(ClassName)
	CreateClass = FALSE ' Assume Failure
	' SchemaObj is global
	Dim NewClassObj

	On Error Resume Next
	Set NewClassObj = SchemaObj.Create ("Class", ClassName)
	NewClassObj.SetInfo ' save to metabase
	If Err.Number <> 0 Then
		Exit Function
	End If
	On Error Goto 0

	CreateClass = TRUE ' Indicate Success
End Function

'''''''''''''''''''''''''''''''''''''''''''''
'   Create ODBCConnectionString Property.   '
'''''''''''''''''''''''''''''''''''''''''''''
Function CreateProperty(PropertyName, Syntax)
	CreateProperty = FALSE ' Assume Failure
	' SchemaObj is a global var
	Dim NewPropertyObj

	On Error Resume Next
	Set NewPropertyObj = SchemaObj.Create ("Property", PropertyName)
	If Trim(Syntax) = "" Then Syntax = "string" ' default is String
	NewPropertyObj.Syntax = Syntax ' Set the syntax; must do pre-save
	NewPropertyObj.SetInfo ' save to the metabase
	NewPropertyObj.Inherit = True ' Set attributes by inheritance
	NewPropertyObj.SetInfo ' save to the metabase
	If Err.Number <> 0 Then
		Exit Function
	End If
	On Error Goto 0

	CreateProperty = TRUE ' Indicate Success
End Function

'''''''''''''''''''''''''''''''''''''''
'   Add the Properties to the Class   '
'''''''''''''''''''''''''''''''''''''''
Function AddToClass(ClassName, PropertyName)
	AddToClass = FALSE ' Assume Failure
	'MachineName is a global constant
	Dim NewClassObj, OptPropList, cnt

	On Error Resume Next
	'Get the class object
	Set NewClassObj = GetObject ("IIS://" & MachineName & "/Schema/" & ClassName)

	'Get the optional properties list
	OptPropList = NewClassObj.OptionalProperties
	cnt = UBound(OptProplist)

	'Add the new property to the array
	ReDim Preserve OptPropList(cnt+1)
	OptPropList(cnt+1) = PropertyName

	'Write the values to the metabase
	NewClassObj.OptionalProperties = OptPropList
	NewClassObj.SetInfo
	If Err.Number <> 0 Then
		Exit Function
	End If
	On Error Goto 0

	AddToClass = TRUE ' Indicate Success
End Function

''''''''''''''''''''''''''''''''''''''''
'   Remove Properties from the Class   '
''''''''''''''''''''''''''''''''''''''''
Function RemoveFromClass(ClassName, PropertyName)
	RemoveFromClass = FALSE ' Assume Failure
	'MachineName is a global constant
	Dim NewClassObj, OptPropList, cnt

	On Error Resume Next
	'Get the class object
	Set NewClassObj = GetObject ("IIS://" & MachineName & "/Schema/" & ClassName)

	'Get the optional properties list
	OptPropList = NewClassObj.OptionalProperties
	cnt = UBound(OptProplist)

	Dim temparraycount
	ReDim temparraycount (cnt-1)
	Dim tempcount1
	Dim tempcount2
	tempcount1 = 0
	tempcount2 = 0

	do while (tempcount2 <= cnt)
		If ( OptProplist(tempcount2) <> PropertyName) Then
		temparraycount (tempcount1) = OptPropList (tempcount2)
		tempcount1 = tempcount1 + 1
	End If
	tempcount2 = tempcount2 + 1
	Loop
   
	NewClassObj.OptionalProperties = temparraycount
	If Err.Number <> 0 Then
		Exit Function
	End If
	On Error Goto 0

	RemoveFromClass = TRUE ' Indicate Success
End Function
